#This source code is able to freely use for Blender and users.

bl_info = {
    "name": "Select n-gon faces",
    "author": "TMO",
    "version": (0, 1, 0),
    "blender": (2, 6, 0),
    "location": "View3D > Select > Select n-gon faces",
    "description": "Select n-gon faces",
    "warning": "",
    "wiki_url": "http://www.sousakuba.com/blender/index.html",
    "tracker_url": "",
    "category": "3D View"}

import os
import bpy
from bpy.props import StringProperty
from bpy.props import *

import mathutils
from mathutils import Vector, Matrix

class MSG():
    msg_type = ''
    msg = ''

class MessageBox(bpy.types.Operator, MSG):
    bl_idname = 'va.msg_box'
    bl_label = ''

    def draw(self, context):
        if self.msg_type == 'Error':
            self.t = 'ERROR'
        else:
            self.t = 'NONE'

        layout = self.layout
        row = layout.split(0.25)
        row.label(self.msg_type, icon = self.t)
        row.label(self.msg)

    def execute(self, context):
        return {'FINISHED'}

    def invoke(self, context, event):
        return context.window_manager.invoke_popup(self)


def SelectNgons():

    bpy.ops.mesh.select_all(action='DESELECT')
    bpy.ops.object.mode_set(mode='OBJECT')

    mesh = bpy.context.active_object.data

    for poly in mesh.polygons:

        vn = poly.loop_total

        if vn is not 3:
            if vn is not 4:
                poly.select = True

    bpy.ops.object.mode_set(mode='EDIT')

class main(bpy.types.Operator):
    bl_idname="mesh.select_ngon_faces"
    bl_label="Select n-gon faces"
    bl_options = {'REGISTER', 'UNDO'}

    def draw(self, context):
        return

    def execute(self, context):
        SelectNgons()
        return {'FINISHED'}

def menu_func(self, context):
    self.layout.operator(main.bl_idname, main.bl_label, icon="PLUGIN")

def register():
    bpy.utils.register_module(__name__)


    bpy.types.VIEW3D_MT_select_edit_mesh.append(menu_func)

def unregister():
    bpy.utils.unregister_module(__name__)

    bpy.types.VIEW3D_MT_select_edit_mesh.remove(menu_func)

if __name__ == "__main__":
    register()
